Merge tag 'for-linus-6.4-1' of https://github.com/cminyard/linux-ipmi
[linux-block.git] / usr / gen_initramfs.sh
CommitLineData
153f0114 1#!/bin/sh
1da177e4 2# Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
f6112ec2 3# Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
1da177e4 4#
d39a206b 5# Released under the terms of the GNU GPL
1da177e4 6#
d39a206b 7# Generate a cpio packed initramfs. It uses gen_init_cpio to generate
65e00e04 8# the cpio archive.
d39a206b
SR
9# This script assumes that gen_init_cpio is located in usr/ directory
10
11# error out on errors
12set -e
13
14usage() {
15cat << EOF
16Usage:
96680975 17$0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
65e00e04 18 -o <file> Create initramfs file named <file> by using gen_init_cpio
96680975 19 -l <dep_list> Create dependency list named <dep_list>
d39a206b 20 -u <uid> User ID to map to user ID 0 (root).
4c6f2eb9
MF
21 <uid> is only meaningful if <cpio_source> is a
22 directory. "squash" forces all files to uid 0.
d39a206b 23 -g <gid> Group ID to map to group ID 0 (root).
4c6f2eb9
MF
24 <gid> is only meaningful if <cpio_source> is a
25 directory. "squash" forces all files to gid 0.
d39a206b 26 <cpio_source> File list or directory for cpio archive.
f6112ec2 27 If <cpio_source> is a .cpio file it will be used
d39a206b 28 as direct input to initramfs.
d39a206b
SR
29
30All options except -o and -l may be repeated and are interpreted
31sequentially and immediately. -u and -g states are preserved across
32<cpio_source> options so an explicit "-u 0 -g 0" is required
33to reset the root/group mapping.
34EOF
35}
36
f6112ec2
OV
37# awk style field access
38# $1 - field number; rest is argument string
39field() {
40 shift $1 ; echo $1
41}
42
1da177e4
LT
43filetype() {
44 local argv1="$1"
45
46 # symlink test must come before file test
47 if [ -L "${argv1}" ]; then
48 echo "slink"
49 elif [ -f "${argv1}" ]; then
50 echo "file"
51 elif [ -d "${argv1}" ]; then
52 echo "dir"
53 elif [ -b "${argv1}" -o -c "${argv1}" ]; then
54 echo "nod"
55 elif [ -p "${argv1}" ]; then
56 echo "pipe"
57 elif [ -S "${argv1}" ]; then
58 echo "sock"
59 else
60 echo "invalid"
61 fi
62 return 0
63}
64
65print_mtime() {
1da177e4
LT
66 local my_mtime="0"
67
d39a206b
SR
68 if [ -e "$1" ]; then
69 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
1da177e4 70 fi
d39a206b 71
469e87e8
MY
72 echo "# Last modified: ${my_mtime}" >> $cpio_list
73 echo "" >> $cpio_list
d39a206b
SR
74}
75
76list_parse() {
96680975 77 if [ -z "$dep_list" -o -L "$1" ]; then
590abbdd
MM
78 return
79 fi
96680975 80 echo "$1" | sed 's/:/\\:/g; s/$/ \\/' >> $dep_list
1da177e4
LT
81}
82
d39a206b
SR
83# for each file print a line in following format
84# <filetype> <name> <path to file> <octal mode> <uid> <gid>
85# for links, devices etc the format differs. See gen_init_cpio for details
1da177e4
LT
86parse() {
87 local location="$1"
153f0114 88 local name="/${location#${srcdir}}"
1da177e4 89 # change '//' into '/'
153f0114 90 name=$(echo "$name" | sed -e 's://*:/:g')
1da177e4
LT
91 local mode="$2"
92 local uid="$3"
93 local gid="$4"
94 local ftype=$(filetype "${location}")
95 # remap uid/gid to 0 if necessary
4c6f2eb9
MF
96 [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
97 [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
1da177e4
LT
98 local str="${mode} ${uid} ${gid}"
99
153f0114
JS
100 [ "${ftype}" = "invalid" ] && return 0
101 [ "${location}" = "${srcdir}" ] && return 0
1da177e4
LT
102
103 case "${ftype}" in
104 "file")
105 str="${ftype} ${name} ${location} ${str}"
106 ;;
107 "nod")
cc976614 108 local dev="`LC_ALL=C ls -l "${location}"`"
f6112ec2
OV
109 local maj=`field 5 ${dev}`
110 local min=`field 6 ${dev}`
111 maj=${maj%,}
112
113 [ -b "${location}" ] && dev="b" || dev="c"
114
115 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
1da177e4
LT
116 ;;
117 "slink")
b5a5e4c7 118 local target=`readlink "${location}"`
1da177e4
LT
119 str="${ftype} ${name} ${target} ${str}"
120 ;;
121 *)
122 str="${ftype} ${name} ${str}"
123 ;;
124 esac
125
469e87e8 126 echo "${str}" >> $cpio_list
1da177e4
LT
127
128 return 0
129}
130
d39a206b
SR
131unknown_option() {
132 printf "ERROR: unknown option \"$arg\"\n" >&2
133 printf "If the filename validly begins with '-', " >&2
134 printf "then it must be prefixed\n" >&2
135 printf "by './' so that it won't be interpreted as an option." >&2
136 printf "\n" >&2
137 usage >&2
138 exit 1
139}
140
d39a206b 141header() {
469e87e8 142 printf "\n#####################\n# $1\n" >> $cpio_list
d39a206b
SR
143}
144
145# process one directory (incl sub-directories)
146dir_filelist() {
96680975 147 header "$1"
d39a206b
SR
148
149 srcdir=$(echo "$1" | sed -e 's://*:/:g')
77a88274 150 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n" | LC_ALL=C sort)
d39a206b
SR
151
152 # If $dirlist is only one line, then the directory is empty
153 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
96680975 154 print_mtime "$1"
d39a206b
SR
155
156 echo "${dirlist}" | \
157 while read x; do
96680975
MY
158 list_parse $x
159 parse $x
d39a206b
SR
160 done
161 fi
1da177e4
LT
162}
163
d39a206b
SR
164input_file() {
165 source="$1"
166 if [ -f "$1" ]; then
65e00e04
MY
167 # If a regular file is specified, assume it is in
168 # gen_init_cpio format
96680975 169 header "$1"
469e87e8
MY
170 print_mtime "$1" >> $cpio_list
171 cat "$1" >> $cpio_list
96680975
MY
172 if [ -n "$dep_list" ]; then
173 echo "$1 \\" >> $dep_list
46ed981d 174 cat "$1" | while read type dir file perm ; do
153f0114 175 if [ "$type" = "file" ]; then
96680975 176 echo "$file \\" >> $dep_list
46ed981d
SR
177 fi
178 done
1da177e4 179 fi
d39a206b 180 elif [ -d "$1" ]; then
65e00e04 181 # If a directory is specified then add all files in it to fs
d39a206b 182 dir_filelist "$1"
1da177e4 183 else
d39a206b 184 echo " ${prog}: Cannot open '$1'" >&2
1da177e4
LT
185 exit 1
186 fi
187}
188
d39a206b 189prog=$0
1da177e4
LT
190root_uid=0
191root_gid=0
d39a206b 192dep_list=
469e87e8 193cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
d39a206b 194output="/dev/stdout"
1da177e4 195
7168965e
MY
196trap "rm -f $cpio_list" EXIT
197
1da177e4
LT
198while [ $# -gt 0 ]; do
199 arg="$1"
200 shift
201 case "$arg" in
96680975
MY
202 "-l") # files included in initramfs - used by kbuild
203 dep_list="$1"
204 echo "deps_initramfs := \\" > $dep_list
205 shift
206 ;;
65e00e04
MY
207 "-o") # generate cpio image named $1
208 output="$1"
96680975
MY
209 shift
210 ;;
d39a206b 211 "-u") # map $1 to uid=0 (root)
1da177e4 212 root_uid="$1"
595a22ac 213 [ "$root_uid" = "-1" ] && root_uid=$(id -u || echo 0)
1da177e4
LT
214 shift
215 ;;
d39a206b 216 "-g") # map $1 to gid=0 (root)
1da177e4 217 root_gid="$1"
595a22ac 218 [ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
1da177e4
LT
219 shift
220 ;;
1da177e4
LT
221 "-h")
222 usage
223 exit 0
224 ;;
225 *)
226 case "$arg" in
227 "-"*)
d39a206b 228 unknown_option
1da177e4 229 ;;
d39a206b 230 *) # input file/dir - process it
65e00e04 231 input_file "$arg"
1da177e4
LT
232 ;;
233 esac
234 ;;
235 esac
236done
237
65e00e04 238# If output_file is set we will generate cpio archive
25985edc 239# we are careful to delete tmp files
65e00e04
MY
240timestamp=
241if test -n "$KBUILD_BUILD_TIMESTAMP"; then
242 timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
243 if test -n "$timestamp"; then
244 timestamp="-t $timestamp"
c299ec2d 245 fi
d39a206b 246fi
65e00e04 247usr/gen_init_cpio $timestamp $cpio_list > $output